/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.internal.ui;

/**
 * Image constants for use with Images class.
 * 
 * @author jgarnett
 */
public interface ImageConstants {
	
	/**
	 * Enabled toolbar icons
	 */
	public final static String PATH_ETOOL = "etool16/"; //$NON-NLS-1$

    /** <code>NEW_WIZ</code> field */
    public final static String NEW_WIZ = PATH_ETOOL + "new_wiz.gif"; //$NON-NLS-1$

    /**
	 * Disabled toolbar icons.
	 */
	//public final static String PATH_DTOOL = ICONS_PATH+"dtool16/"; //$NON-NLS-1$
	
	/**
	 * Enabled local toolbar icons.
	 */
	public final static String PATH_ELOCALTOOL = "elcl16/"; //$NON-NLS-1$    
    /** <code>FIRST_CO</code> field */
    public final static String FIRST_CO = PATH_ETOOL + "next_co.gif"; //$NON-NLS-1$
    /** <code>PREV_CO</code> field */
    public final static String PREV_CO = PATH_ETOOL + "prev_co.gif"; //$NON-NLS-1$
    /** <code>NEXT_CO</code> field */
    public final static String NEXT_CO = PATH_ETOOL + "next_co.gif"; //$NON-NLS-1$
    /** <code>LAST_CO</code> field */
    public final static String LAST_CO = PATH_ETOOL + "last_co.gif"; //$NON-NLS-1$
    
	
	/**
	 * Disabled local toolbar icons
	 */
	public final static String PATH_DLOCALTOOL = "dlcl16/"; //$NON-NLS-1$
	
	/**
	 * View icons
	 */
	public final static String PATH_EVIEW = "eview16/"; //$NON-NLS-1$
	
	/**
	 * Product images
	 */
	public final static String PATH_PROD = "prod/";	//$NON-NLS-1$
	
	/**
	 * Model object icons
	 */
	public final static String PATH_OBJECT = "obj16/"; //$NON-NLS-1$
	
	/**
	 * Pointer icons
	 */
	public final static String PATH_POINTER = "pointer/";  //$NON-NLS-1$
	
	/**
	 * Wizard banners
	 */
	public final static String PATH_WIZBAN = "wizban/"; //$NON-NLS-1$

    /** <code>LOG_WIZ</code> field */
    public final static String LOG_WIZ = PATH_WIZBAN + "log_wiz.png"; //$NON-NLS-1$

	/**
	 * Misc icons
	 */
	public final static String PATH_MISC = "misc/"; //$NON-NLS-1$
	
	/**
	 * icons Overlays
	 */
	public final static String PATH_OVERLAY = "ovr16/"; //$NON-NLS-1$
		
}
