/*
 * Created on Jun 23, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.refractions.udig.internal.ui;
import java.awt.Rectangle;
import java.rmi.server.UID;
import java.util.Iterator;
import java.util.Set;

import javax.units.SI;

import net.refractions.udig.ui.graphics.SWTGraphics;
import net.refractions.udig.ui.internal.Messages;

import org.eclipse.core.runtime.IPlatformRunnable;
import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Path;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.application.WorkbenchAdvisor;
import org.geotools.referencing.ReferencingFactoryFinder;

public class UDIGApplication implements IPlatformRunnable {

    @SuppressWarnings("unused")
    public Object run(Object args) {
        WorkbenchAdvisor workbenchAdvisor = new UDIGWorkbenchAdvisor();
        Display display = PlatformUI.createDisplay();

        boolean shutdown=init();
        if( shutdown )
            return IPlatformRunnable.EXIT_OK;
        
        int returnCode=IPlatformRunnable.EXIT_OK;
        try {
            returnCode = PlatformUI.createAndRunWorkbench(display,
                    workbenchAdvisor);
        } catch(Throwable t){
            UiPlugin.log(Messages.UDIGApplication_error, t);             
        }finally {
        	Platform.endSplash();
            display.dispose();
        }
        if (returnCode == PlatformUI.RETURN_RESTART)
            return IPlatformRunnable.EXIT_RESTART;
        return IPlatformRunnable.EXIT_OK;
    }

    private boolean init() {
        checkForJAI();
        
        if ( !checkForGDI() )
            return true;

        loadCommonlyUsedObject();
        
        return false;
    }

    private void loadCommonlyUsedObject() {
        //potential fix for win32 (occasionally blocks in Drawing.feature(Point/etc) during first render)
        new UID(); //seed the random number generator
        
        load(ReferencingFactoryFinder.getCoordinateOperationAuthorityFactories( null ));
        load(ReferencingFactoryFinder.getCoordinateOperationAuthorityFactories( null ));
        load(ReferencingFactoryFinder.getCRSFactories(null));
        load(ReferencingFactoryFinder.getCSFactories(null));
        load(ReferencingFactoryFinder.getDatumAuthorityFactories(null));
        load(ReferencingFactoryFinder.getDatumFactories(null));
        load(ReferencingFactoryFinder.getMathTransformFactories(null));
        @SuppressWarnings("unused")
        Object o=SI.BIT;
        o=SI.GRAM;
        o=SI.KILOGRAM;
        o=SI.METER;
        o=SI.RADIAN;
        o=SI.SECOND;
        o=SI.STERADIAN;
   }

    private void load( Set coordinateOperationAuthorityFactories ) {
        for( Iterator iter = coordinateOperationAuthorityFactories.iterator(); iter.hasNext(); ) {
            iter.next();
        }
    }

    private boolean checkForGDI() {
        if( Platform.getOS().equals(Platform.OS_WIN32) ){
            // test to make sure that GDI+ is installed
            Image image=null;
            Path path = null;
            try{
                image=new Image(Display.getCurrent(),10,10);
                path = SWTGraphics.convertToPath(new Rectangle(0,0,8,8), Display.getCurrent());
            }catch (Exception e) {
                MessageDialog.openError(Display.getCurrent().getActiveShell(),Messages.UDIGApplication_title, 
                        Messages.UDIGApplication_error1 + 
                        Messages.UDIGApplication_error2 + 
                        "http://www.microsoft.com/downloads/details.aspx?FamilyID=6A63AB9C-DF12-4D41-933C-BE590FEAA05A&displaylang=en"); //$NON-NLS-1$
                return false;
            }finally{
                if( image!=null )
                    image.dispose();
                if( path!=null )
                    path.dispose();
            }
        }
        return true;
    }

    private void checkForJAI() {
        try{
            Class.forName("javax.media.jai.operator.OrDescriptor"); //$NON-NLS-1$
        }catch(Throwable th){
        	JaiErrorDialog.display();
        }
    }
}