/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.ui;

import org.eclipse.ui.IWorkbenchActionConstants;

/**
 * General constants used by the uDig Application.
 */
public interface Constants {
    // Note:  all menus have a IWorkbenchActionConstants group
    
    // Group Markers for the File menu in the menu bar
    public static final String FILE_START=IWorkbenchActionConstants.FILE_START;
    public static final String OPEN_EXT=IWorkbenchActionConstants.OPEN_EXT;
    public static final String CLOSE_EXT=IWorkbenchActionConstants.CLOSE_EXT;
    public static final String SAVE_EXT=IWorkbenchActionConstants.SAVE_EXT;
    public static final String FILE_END=IWorkbenchActionConstants.FILE_END;
    public static final String CONFIG_EXT = "config.ext"; //$NON-NLS-1$
    public static final String COMMIT_EXT = "commit.ext"; //$NON-NLS-1$
    public static final String NEW_START = "new.start"; //$NON-NLS-1$
    public static final String RENAME_EXT = "rename.ext"; //$NON-NLS-1$
    public static final String REVERT_EXT = "revert.ext"; //$NON-NLS-1$
    
    // Group Marker for the Edit menu in the menu bar
    public static final String EDIT_START=IWorkbenchActionConstants.EDIT_START;
    public static final String UNDO_EXT=IWorkbenchActionConstants.UNDO_EXT;
    public static final String CUT_EXT=IWorkbenchActionConstants.CUT_EXT;
    public static final String ADD_EXT=IWorkbenchActionConstants.ADD_EXT;
    public static final String EDIT_END=IWorkbenchActionConstants.EDIT_END;
    // Group Marker for the Navigation menu in the menu bar
    public static final String M_NAVIGATE=IWorkbenchActionConstants.M_NAVIGATE;
    public static final String NAV_START=IWorkbenchActionConstants.NAV_START;
    public static final String NAV_ZOOM_EXT="zoom.ext"; //$NON-NLS-1$
    public static final String NAV_BOTTOM="bottom"; //$NON-NLS-1$
    // Group Marker for the Layer menu in the menu bar
    public static final String M_LAYER="layer"; //$NON-NLS-1$
    public static final String LAYER_ADD_EXT="add.ext"; //$NON-NLS-1$
    public static final String LAYER_EDIT_EXT="edit.ext"; //$NON-NLS-1$
    public static final String LAYER_MAPGRAPHIC_EXT="mapGraphic.ext"; //$NON-NLS-1$
    public static final String LAYER_MAPGRAPHIC_OTHER="mapGraphicOther.ext"; //$NON-NLS-1$
    
    // Group Marker for the Window menu in the menu bar - Only MB_ADDITIONS
    // Group Marker for the Tool menu in the menu bar
    public static final String M_TOOL="tools"; //$NON-NLS-1$
    public static final String TOOL_ACTION="action.ext"; //$NON-NLS-1$
    public static final String TOOL_MODAL="modal.ext"; //$NON-NLS-1$
    // Group Marker for the Help menu in the menu bar
    public static final String HELP_START=IWorkbenchActionConstants.HELP_START;
    public static final String HELP_END=IWorkbenchActionConstants.HELP_END;
    
    
}
