package net.refractions.udig.ui.preferences;

import net.refractions.udig.ui.FeatureTypeEditor;

/**
 * Constant definitions for plug-in preferences
 */
public class PreferenceConstants {

    /**
     * Work around for a bug in SWT on linux.  Allows the use of advancedGraphics to be turned off.
     */
	public static final String P_ADVANCED_GRAPHICS = "advancedGraphics"; //$NON-NLS-1$
    
    /**
     * Fully qualified extension id pointing to an extension instance of point 
     * "net.refractions.udig.ui.workbenchConfigurations". The value specified by
     * the extension id will be called upon to configure the workbench when it 
     * starts up.
     */
    public static final String P_WORKBENCH_CONFIGURATION = "workbenchConfiguration"; //$NON-NLS-1$
    
    /**
     * Fully qualified extension id pointing to an instance of extension point
     * "net.refractions.udig.ui.menuBuilders". The MenuBuilder specified by the
     * extension will be called by uDig to configure the menubar and coolbar.
     */
    public static final String P_MENU_BUILDER = "menuBuilder"; //$NON-NLS-1$
    
    /**
     * The CRS to use by default when creating a new FeatureType with the {@link FeatureTypeEditor}
     * 
     * It may be an EPSG code like "EPSG:3005" or wkt 
     */
    public static final String P_DEFAULT_GEOMEMTRY_CRS = "P_DEFAULT_GEOMEMTRY_CRS"; //$NON-NLS-1$

	public static final String P_DEFAULT_PERSPECTIVE = "defaultPerspective";

    /**
     * Controls whether the TipDialog should be displayed by default on startup.
     * Defaults to true, but can be set in plugin_customization.ini. 
     * Valid values: "true" or "false"
     */
    public static final String P_SHOW_TIPS = "showTips"; //$NON-NLS-1$

}
