/* uDig - User Friendly Desktop Internet GIS client
 * http://udig.refractions.net
 * (C) 2004, Refractions Research Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */
package net.refractions.udig.printing.model.impl;

import java.awt.Color;
import java.awt.Graphics2D;

import net.refractions.udig.printing.model.AbstractBoxPrinter;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.ui.IMemento;

/**
 * Box printer for map labels. 
 * 
 * @author Jesse
 * @since 1.1.0
 */
public class LabelBoxPrinter extends AbstractBoxPrinter {

    private String text="Set Text"; //$NON-NLS-1$
    

    public String getText() {
        return text;
    }

    public void setText( String text ) {
        this.text = text;
    }

    public void draw( Graphics2D graphics, IProgressMonitor monitor ) {
        graphics.setColor(Color.BLACK);
        graphics.drawString(getText(), 10, 10+graphics.getFont().getSize());
    }

    public void createPreview( Graphics2D graphics, IProgressMonitor monitor ) {
        draw(graphics, monitor);
        preview=getText();
        previewSize = getBox().getSize();
    }
    String preview;
	private Dimension previewSize;

    public boolean isNewPreviewNeeded() {
        return (preview!=null && !preview.equals(getText())) || (previewSize != null && !getBox().getSize().equals(previewSize));
    }

    public void save(IMemento memento) {
        memento.putString("label", text); //$NON-NLS-1$
    }

    public void load( IMemento value ) {
        text=value.getString("label"); //$NON-NLS-1$
    }

    public String getExtensionPointID() {
        return "net.refractions.udig.printing.ui.standardBoxes"; //$NON-NLS-1$
    }


}
